require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_FCNTL_H)) {
    die("Never use <bits/fcntl-linux.h> directly; include <fcntl.h> instead.");
}
if(defined(&__USE_GNU)) {
    require 'bits/types/struct_iovec.ph';
}
eval 'sub O_ACCMODE () {0003;}' unless defined(&O_ACCMODE);
eval 'sub O_RDONLY () {00;}' unless defined(&O_RDONLY);
eval 'sub O_WRONLY () {01;}' unless defined(&O_WRONLY);
eval 'sub O_RDWR () {02;}' unless defined(&O_RDWR);
unless(defined(&O_CREAT)) {
    eval 'sub O_CREAT () {0100;}' unless defined(&O_CREAT);
}
unless(defined(&O_EXCL)) {
    eval 'sub O_EXCL () {0200;}' unless defined(&O_EXCL);
}
unless(defined(&O_NOCTTY)) {
    eval 'sub O_NOCTTY () {0400;}' unless defined(&O_NOCTTY);
}
unless(defined(&O_TRUNC)) {
    eval 'sub O_TRUNC () {01000;}' unless defined(&O_TRUNC);
}
unless(defined(&O_APPEND)) {
    eval 'sub O_APPEND () {02000;}' unless defined(&O_APPEND);
}
unless(defined(&O_NONBLOCK)) {
    eval 'sub O_NONBLOCK () {04000;}' unless defined(&O_NONBLOCK);
}
unless(defined(&O_NDELAY)) {
    eval 'sub O_NDELAY () { &O_NONBLOCK;}' unless defined(&O_NDELAY);
}
unless(defined(&O_SYNC)) {
    eval 'sub O_SYNC () {04010000;}' unless defined(&O_SYNC);
}
eval 'sub O_FSYNC () { &O_SYNC;}' unless defined(&O_FSYNC);
unless(defined(&O_ASYNC)) {
    eval 'sub O_ASYNC () {020000;}' unless defined(&O_ASYNC);
}
unless(defined(&__O_LARGEFILE)) {
    eval 'sub __O_LARGEFILE () {0100000;}' unless defined(&__O_LARGEFILE);
}
unless(defined(&__O_DIRECTORY)) {
    eval 'sub __O_DIRECTORY () {0200000;}' unless defined(&__O_DIRECTORY);
}
unless(defined(&__O_NOFOLLOW)) {
    eval 'sub __O_NOFOLLOW () {0400000;}' unless defined(&__O_NOFOLLOW);
}
unless(defined(&__O_CLOEXEC)) {
    eval 'sub __O_CLOEXEC () {02000000;}' unless defined(&__O_CLOEXEC);
}
unless(defined(&__O_DIRECT)) {
    eval 'sub __O_DIRECT () {040000;}' unless defined(&__O_DIRECT);
}
unless(defined(&__O_NOATIME)) {
    eval 'sub __O_NOATIME () {01000000;}' unless defined(&__O_NOATIME);
}
unless(defined(&__O_PATH)) {
    eval 'sub __O_PATH () {010000000;}' unless defined(&__O_PATH);
}
unless(defined(&__O_DSYNC)) {
    eval 'sub __O_DSYNC () {010000;}' unless defined(&__O_DSYNC);
}
unless(defined(&__O_TMPFILE)) {
    eval 'sub __O_TMPFILE () {(020000000|  &__O_DIRECTORY);}' unless defined(&__O_TMPFILE);
}
unless(defined(&F_GETLK)) {
    if(!defined (&__USE_FILE_OFFSET64)  && (defined(&__TIMESIZE) ? &__TIMESIZE : undef) != 64) {
	eval 'sub F_GETLK () {5;}' unless defined(&F_GETLK);
	eval 'sub F_SETLK () {6;}' unless defined(&F_SETLK);
	eval 'sub F_SETLKW () {7;}' unless defined(&F_SETLKW);
    } else {
	eval 'sub F_GETLK () { &F_GETLK64;}' unless defined(&F_GETLK);
	eval 'sub F_SETLK () { &F_SETLK64;}' unless defined(&F_SETLK);
	eval 'sub F_SETLKW () { &F_SETLKW64;}' unless defined(&F_SETLKW);
    }
}
unless(defined(&F_GETLK64)) {
    eval 'sub F_GETLK64 () {12;}' unless defined(&F_GETLK64);
    eval 'sub F_SETLK64 () {13;}' unless defined(&F_SETLK64);
    eval 'sub F_SETLKW64 () {14;}' unless defined(&F_SETLKW64);
}
if(defined(&__USE_GNU)) {
    eval 'sub F_OFD_GETLK () {36;}' unless defined(&F_OFD_GETLK);
    eval 'sub F_OFD_SETLK () {37;}' unless defined(&F_OFD_SETLK);
    eval 'sub F_OFD_SETLKW () {38;}' unless defined(&F_OFD_SETLKW);
}
if(defined(&__USE_LARGEFILE64)) {
    eval 'sub O_LARGEFILE () { &__O_LARGEFILE;}' unless defined(&O_LARGEFILE);
}
if(defined(&__USE_XOPEN2K8)) {
    eval 'sub O_DIRECTORY () { &__O_DIRECTORY;}' unless defined(&O_DIRECTORY);
    eval 'sub O_NOFOLLOW () { &__O_NOFOLLOW;}' unless defined(&O_NOFOLLOW);
    eval 'sub O_CLOEXEC () { &__O_CLOEXEC;}' unless defined(&O_CLOEXEC);
}
if(defined(&__USE_GNU)) {
    eval 'sub O_DIRECT () { &__O_DIRECT;}' unless defined(&O_DIRECT);
    eval 'sub O_NOATIME () { &__O_NOATIME;}' unless defined(&O_NOATIME);
    eval 'sub O_PATH () { &__O_PATH;}' unless defined(&O_PATH);
    eval 'sub O_TMPFILE () { &__O_TMPFILE;}' unless defined(&O_TMPFILE);
}
if(defined (&__USE_POSIX199309) || defined (&__USE_UNIX98)) {
    eval 'sub O_DSYNC () { &__O_DSYNC;}' unless defined(&O_DSYNC);
    if(defined (&__O_RSYNC)) {
	eval 'sub O_RSYNC () { &__O_RSYNC;}' unless defined(&O_RSYNC);
    } else {
	eval 'sub O_RSYNC () { &O_SYNC;}' unless defined(&O_RSYNC);
    }
}
eval 'sub F_DUPFD () {0;}' unless defined(&F_DUPFD);
eval 'sub F_GETFD () {1;}' unless defined(&F_GETFD);
eval 'sub F_SETFD () {2;}' unless defined(&F_SETFD);
eval 'sub F_GETFL () {3;}' unless defined(&F_GETFL);
eval 'sub F_SETFL () {4;}' unless defined(&F_SETFL);
unless(defined(&__F_SETOWN)) {
    eval 'sub __F_SETOWN () {8;}' unless defined(&__F_SETOWN);
    eval 'sub __F_GETOWN () {9;}' unless defined(&__F_GETOWN);
}
if(defined (&__USE_UNIX98) || defined (&__USE_XOPEN2K8)) {
    eval 'sub F_SETOWN () { &__F_SETOWN;}' unless defined(&F_SETOWN);
    eval 'sub F_GETOWN () { &__F_GETOWN;}' unless defined(&F_GETOWN);
}
unless(defined(&__F_SETSIG)) {
    eval 'sub __F_SETSIG () {10;}' unless defined(&__F_SETSIG);
    eval 'sub __F_GETSIG () {11;}' unless defined(&__F_GETSIG);
}
unless(defined(&__F_SETOWN_EX)) {
    eval 'sub __F_SETOWN_EX () {15;}' unless defined(&__F_SETOWN_EX);
    eval 'sub __F_GETOWN_EX () {16;}' unless defined(&__F_GETOWN_EX);
}
if(defined(&__USE_GNU)) {
    eval 'sub F_SETSIG () { &__F_SETSIG;}' unless defined(&F_SETSIG);
    eval 'sub F_GETSIG () { &__F_GETSIG;}' unless defined(&F_GETSIG);
    eval 'sub F_SETOWN_EX () { &__F_SETOWN_EX;}' unless defined(&F_SETOWN_EX);
    eval 'sub F_GETOWN_EX () { &__F_GETOWN_EX;}' unless defined(&F_GETOWN_EX);
}
if(defined(&__USE_GNU)) {
    eval 'sub F_SETLEASE () {1024;}' unless defined(&F_SETLEASE);
    eval 'sub F_GETLEASE () {1025;}' unless defined(&F_GETLEASE);
    eval 'sub F_NOTIFY () {1026;}' unless defined(&F_NOTIFY);
    eval 'sub F_SETPIPE_SZ () {1031;}' unless defined(&F_SETPIPE_SZ);
    eval 'sub F_GETPIPE_SZ () {1032;}' unless defined(&F_GETPIPE_SZ);
    eval 'sub F_ADD_SEALS () {1033;}' unless defined(&F_ADD_SEALS);
    eval 'sub F_GET_SEALS () {1034;}' unless defined(&F_GET_SEALS);
    eval 'sub F_GET_RW_HINT () {1035;}' unless defined(&F_GET_RW_HINT);
    eval 'sub F_SET_RW_HINT () {1036;}' unless defined(&F_SET_RW_HINT);
    eval 'sub F_GET_FILE_RW_HINT () {1037;}' unless defined(&F_GET_FILE_RW_HINT);
    eval 'sub F_SET_FILE_RW_HINT () {1038;}' unless defined(&F_SET_FILE_RW_HINT);
}
if(defined(&__USE_XOPEN2K8)) {
    eval 'sub F_DUPFD_CLOEXEC () {1030;}' unless defined(&F_DUPFD_CLOEXEC);
}
eval 'sub FD_CLOEXEC () {1;}' unless defined(&FD_CLOEXEC);
unless(defined(&F_RDLCK)) {
    eval 'sub F_RDLCK () {0;}' unless defined(&F_RDLCK);
    eval 'sub F_WRLCK () {1;}' unless defined(&F_WRLCK);
    eval 'sub F_UNLCK () {2;}' unless defined(&F_UNLCK);
}
unless(defined(&F_EXLCK)) {
    eval 'sub F_EXLCK () {4;}' unless defined(&F_EXLCK);
    eval 'sub F_SHLCK () {8;}' unless defined(&F_SHLCK);
}
if(defined(&__USE_MISC)) {
    eval 'sub LOCK_SH () {1;}' unless defined(&LOCK_SH);
    eval 'sub LOCK_EX () {2;}' unless defined(&LOCK_EX);
    eval 'sub LOCK_NB () {4;}' unless defined(&LOCK_NB);
    eval 'sub LOCK_UN () {8;}' unless defined(&LOCK_UN);
}
if(defined(&__USE_GNU)) {
    eval 'sub LOCK_MAND () {32;}' unless defined(&LOCK_MAND);
    eval 'sub LOCK_READ () {64;}' unless defined(&LOCK_READ);
    eval 'sub LOCK_WRITE () {128;}' unless defined(&LOCK_WRITE);
    eval 'sub LOCK_RW () {192;}' unless defined(&LOCK_RW);
}
if(defined(&__USE_GNU)) {
    eval 'sub DN_ACCESS () {0x1;}' unless defined(&DN_ACCESS);
    eval 'sub DN_MODIFY () {0x2;}' unless defined(&DN_MODIFY);
    eval 'sub DN_CREATE () {0x4;}' unless defined(&DN_CREATE);
    eval 'sub DN_DELETE () {0x8;}' unless defined(&DN_DELETE);
    eval 'sub DN_RENAME () {0x10;}' unless defined(&DN_RENAME);
    eval 'sub DN_ATTRIB () {0x20;}' unless defined(&DN_ATTRIB);
    eval 'sub DN_MULTISHOT () {0x80000000;}' unless defined(&DN_MULTISHOT);
}
if(defined(&__USE_GNU)) {
    eval("sub F_OWNER_TID () { 0; }") unless defined(&F_OWNER_TID);
    eval("sub F_OWNER_PID () { 1; }") unless defined(&F_OWNER_PID);
    eval("sub F_OWNER_PGRP () { 2; }") unless defined(&F_OWNER_PGRP);
    eval("sub F_OWNER_GID () { F_OWNER_PGRP; }") unless defined(&F_OWNER_GID);
}
if(defined(&__USE_GNU)) {
    eval 'sub F_SEAL_SEAL () {0x1;}' unless defined(&F_SEAL_SEAL);
    eval 'sub F_SEAL_SHRINK () {0x2;}' unless defined(&F_SEAL_SHRINK);
    eval 'sub F_SEAL_GROW () {0x4;}' unless defined(&F_SEAL_GROW);
    eval 'sub F_SEAL_WRITE () {0x8;}' unless defined(&F_SEAL_WRITE);
    eval 'sub F_SEAL_FUTURE_WRITE () {0x10;}' unless defined(&F_SEAL_FUTURE_WRITE);
    eval 'sub F_SEAL_EXEC () {0x20;}' unless defined(&F_SEAL_EXEC);
}
if(defined(&__USE_GNU)) {
    eval 'sub RWH_WRITE_LIFE_NOT_SET () {0;}' unless defined(&RWH_WRITE_LIFE_NOT_SET);
    eval 'sub RWF_WRITE_LIFE_NOT_SET () { &RWH_WRITE_LIFE_NOT_SET;}' unless defined(&RWF_WRITE_LIFE_NOT_SET);
    eval 'sub RWH_WRITE_LIFE_NONE () {1;}' unless defined(&RWH_WRITE_LIFE_NONE);
    eval 'sub RWH_WRITE_LIFE_SHORT () {2;}' unless defined(&RWH_WRITE_LIFE_SHORT);
    eval 'sub RWH_WRITE_LIFE_MEDIUM () {3;}' unless defined(&RWH_WRITE_LIFE_MEDIUM);
    eval 'sub RWH_WRITE_LIFE_LONG () {4;}' unless defined(&RWH_WRITE_LIFE_LONG);
    eval 'sub RWH_WRITE_LIFE_EXTREME () {5;}' unless defined(&RWH_WRITE_LIFE_EXTREME);
}
if(defined(&__USE_MISC)) {
    eval 'sub FAPPEND () { &O_APPEND;}' unless defined(&FAPPEND);
    eval 'sub FFSYNC () { &O_FSYNC;}' unless defined(&FFSYNC);
    eval 'sub FASYNC () { &O_ASYNC;}' unless defined(&FASYNC);
    eval 'sub FNONBLOCK () { &O_NONBLOCK;}' unless defined(&FNONBLOCK);
    eval 'sub FNDELAY () { &O_NDELAY;}' unless defined(&FNDELAY);
}
unless(defined(&__POSIX_FADV_DONTNEED)) {
    eval 'sub __POSIX_FADV_DONTNEED () {4;}' unless defined(&__POSIX_FADV_DONTNEED);
    eval 'sub __POSIX_FADV_NOREUSE () {5;}' unless defined(&__POSIX_FADV_NOREUSE);
}
if(defined(&__USE_XOPEN2K)) {
    eval 'sub POSIX_FADV_NORMAL () {0;}' unless defined(&POSIX_FADV_NORMAL);
    eval 'sub POSIX_FADV_RANDOM () {1;}' unless defined(&POSIX_FADV_RANDOM);
    eval 'sub POSIX_FADV_SEQUENTIAL () {2;}' unless defined(&POSIX_FADV_SEQUENTIAL);
    eval 'sub POSIX_FADV_WILLNEED () {3;}' unless defined(&POSIX_FADV_WILLNEED);
    eval 'sub POSIX_FADV_DONTNEED () { &__POSIX_FADV_DONTNEED;}' unless defined(&POSIX_FADV_DONTNEED);
    eval 'sub POSIX_FADV_NOREUSE () { &__POSIX_FADV_NOREUSE;}' unless defined(&POSIX_FADV_NOREUSE);
}
if(defined(&__USE_GNU)) {
    eval 'sub SYNC_FILE_RANGE_WAIT_BEFORE () {1;}' unless defined(&SYNC_FILE_RANGE_WAIT_BEFORE);
    eval 'sub SYNC_FILE_RANGE_WRITE () {2;}' unless defined(&SYNC_FILE_RANGE_WRITE);
    eval 'sub SYNC_FILE_RANGE_WAIT_AFTER () {4;}' unless defined(&SYNC_FILE_RANGE_WAIT_AFTER);
    eval 'sub SYNC_FILE_RANGE_WRITE_AND_WAIT () {( &SYNC_FILE_RANGE_WRITE |  &SYNC_FILE_RANGE_WAIT_BEFORE |  &SYNC_FILE_RANGE_WAIT_AFTER);}' unless defined(&SYNC_FILE_RANGE_WRITE_AND_WAIT);
    eval 'sub SPLICE_F_MOVE () {1;}' unless defined(&SPLICE_F_MOVE);
    eval 'sub SPLICE_F_NONBLOCK () {2;}' unless defined(&SPLICE_F_NONBLOCK);
    eval 'sub SPLICE_F_MORE () {4;}' unless defined(&SPLICE_F_MORE);
    eval 'sub SPLICE_F_GIFT () {8;}' unless defined(&SPLICE_F_GIFT);
    require 'linux/falloc.ph';
    eval 'sub MAX_HANDLE_SZ () {128;}' unless defined(&MAX_HANDLE_SZ);
}
if(defined(&__USE_GNU)) {
    eval 'sub AT_HANDLE_FID () { &AT_REMOVEDIR;}' unless defined(&AT_HANDLE_FID);
}
if(defined(&__USE_GNU)) {
    unless(defined(&__USE_FILE_OFFSET64)) {
    } else {
	if(defined(&__REDIRECT)) {
	} else {
	    eval 'sub fallocate () { &fallocate64;}' unless defined(&fallocate);
	}
    }
    if(defined(&__USE_LARGEFILE64)) {
    }
}
1;
