require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&__LINUX_BTF_H__)) {
    eval 'sub __LINUX_BTF_H__ () {1;}' unless defined(&__LINUX_BTF_H__);
    require 'linux/types.ph';
    eval 'sub BTF_MAGIC () {0xeb9f;}' unless defined(&BTF_MAGIC);
    eval 'sub BTF_VERSION () {1;}' unless defined(&BTF_VERSION);
    eval 'sub BTF_MAX_TYPE () {0xfffff;}' unless defined(&BTF_MAX_TYPE);
    eval 'sub BTF_MAX_NAME_OFFSET () {0xffffff;}' unless defined(&BTF_MAX_NAME_OFFSET);
    eval 'sub BTF_MAX_VLEN () {0xffff;}' unless defined(&BTF_MAX_VLEN);
    eval 'sub BTF_INFO_KIND {
        my($info) = @_;
	    eval q(((($info) >> 24) & 0x1f));
    }' unless defined(&BTF_INFO_KIND);
    eval 'sub BTF_INFO_VLEN {
        my($info) = @_;
	    eval q((($info) & 0xffff));
    }' unless defined(&BTF_INFO_VLEN);
    eval 'sub BTF_INFO_KFLAG {
        my($info) = @_;
	    eval q((($info) >> 31));
    }' unless defined(&BTF_INFO_KFLAG);
    eval("sub BTF_KIND_UNKN () { 0; }") unless defined(&BTF_KIND_UNKN);
    eval("sub BTF_KIND_INT () { 1; }") unless defined(&BTF_KIND_INT);
    eval("sub BTF_KIND_PTR () { 2; }") unless defined(&BTF_KIND_PTR);
    eval("sub BTF_KIND_ARRAY () { 3; }") unless defined(&BTF_KIND_ARRAY);
    eval("sub BTF_KIND_STRUCT () { 4; }") unless defined(&BTF_KIND_STRUCT);
    eval("sub BTF_KIND_UNION () { 5; }") unless defined(&BTF_KIND_UNION);
    eval("sub BTF_KIND_ENUM () { 6; }") unless defined(&BTF_KIND_ENUM);
    eval("sub BTF_KIND_FWD () { 7; }") unless defined(&BTF_KIND_FWD);
    eval("sub BTF_KIND_TYPEDEF () { 8; }") unless defined(&BTF_KIND_TYPEDEF);
    eval("sub BTF_KIND_VOLATILE () { 9; }") unless defined(&BTF_KIND_VOLATILE);
    eval("sub BTF_KIND_CONST () { 10; }") unless defined(&BTF_KIND_CONST);
    eval("sub BTF_KIND_RESTRICT () { 11; }") unless defined(&BTF_KIND_RESTRICT);
    eval("sub BTF_KIND_FUNC () { 12; }") unless defined(&BTF_KIND_FUNC);
    eval("sub BTF_KIND_FUNC_PROTO () { 13; }") unless defined(&BTF_KIND_FUNC_PROTO);
    eval("sub BTF_KIND_VAR () { 14; }") unless defined(&BTF_KIND_VAR);
    eval("sub BTF_KIND_DATASEC () { 15; }") unless defined(&BTF_KIND_DATASEC);
    eval("sub BTF_KIND_FLOAT () { 16; }") unless defined(&BTF_KIND_FLOAT);
    eval("sub BTF_KIND_DECL_TAG () { 17; }") unless defined(&BTF_KIND_DECL_TAG);
    eval("sub BTF_KIND_TYPE_TAG () { 18; }") unless defined(&BTF_KIND_TYPE_TAG);
    eval("sub BTF_KIND_ENUM64 () { 19; }") unless defined(&BTF_KIND_ENUM64);
    eval("sub NR_BTF_KINDS () { 20; }") unless defined(&NR_BTF_KINDS);
    eval("sub BTF_KIND_MAX () { NR_BTF_KINDS-1; }") unless defined(&BTF_KIND_MAX);
    eval 'sub BTF_INT_ENCODING {
        my($VAL) = @_;
	    eval q(((($VAL) & 0xf000000) >> 24));
    }' unless defined(&BTF_INT_ENCODING);
    eval 'sub BTF_INT_OFFSET {
        my($VAL) = @_;
	    eval q(((($VAL) & 0xff0000) >> 16));
    }' unless defined(&BTF_INT_OFFSET);
    eval 'sub BTF_INT_BITS {
        my($VAL) = @_;
	    eval q((($VAL) & 0xff));
    }' unless defined(&BTF_INT_BITS);
    eval 'sub BTF_INT_SIGNED () {(1<< 0);}' unless defined(&BTF_INT_SIGNED);
    eval 'sub BTF_INT_CHAR () {(1<< 1);}' unless defined(&BTF_INT_CHAR);
    eval 'sub BTF_INT_BOOL () {(1<< 2);}' unless defined(&BTF_INT_BOOL);
    eval 'sub BTF_MEMBER_BITFIELD_SIZE {
        my($val) = @_;
	    eval q((($val) >> 24));
    }' unless defined(&BTF_MEMBER_BITFIELD_SIZE);
    eval 'sub BTF_MEMBER_BIT_OFFSET {
        my($val) = @_;
	    eval q((($val) & 0xffffff));
    }' unless defined(&BTF_MEMBER_BIT_OFFSET);
    eval("sub BTF_VAR_STATIC () { 0; }") unless defined(&BTF_VAR_STATIC);
    eval("sub BTF_VAR_GLOBAL_ALLOCATED () { 1; }") unless defined(&BTF_VAR_GLOBAL_ALLOCATED);
    eval("sub BTF_VAR_GLOBAL_EXTERN () { 2; }") unless defined(&BTF_VAR_GLOBAL_EXTERN);
    eval("sub BTF_FUNC_STATIC () { 0; }") unless defined(&BTF_FUNC_STATIC);
    eval("sub BTF_FUNC_GLOBAL () { 1; }") unless defined(&BTF_FUNC_GLOBAL);
    eval("sub BTF_FUNC_EXTERN () { 2; }") unless defined(&BTF_FUNC_EXTERN);
}
1;
