require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_NFNETLINK_COMPAT_H)) {
    eval 'sub _NFNETLINK_COMPAT_H () {1;}' unless defined(&_NFNETLINK_COMPAT_H);
    require 'linux/types.ph';
    eval 'sub NF_NETLINK_CONNTRACK_NEW () {0x1;}' unless defined(&NF_NETLINK_CONNTRACK_NEW);
    eval 'sub NF_NETLINK_CONNTRACK_UPDATE () {0x2;}' unless defined(&NF_NETLINK_CONNTRACK_UPDATE);
    eval 'sub NF_NETLINK_CONNTRACK_DESTROY () {0x4;}' unless defined(&NF_NETLINK_CONNTRACK_DESTROY);
    eval 'sub NF_NETLINK_CONNTRACK_EXP_NEW () {0x8;}' unless defined(&NF_NETLINK_CONNTRACK_EXP_NEW);
    eval 'sub NF_NETLINK_CONNTRACK_EXP_UPDATE () {0x10;}' unless defined(&NF_NETLINK_CONNTRACK_EXP_UPDATE);
    eval 'sub NF_NETLINK_CONNTRACK_EXP_DESTROY () {0x20;}' unless defined(&NF_NETLINK_CONNTRACK_EXP_DESTROY);
    eval 'sub NFNL_NFA_NEST () {0x8000;}' unless defined(&NFNL_NFA_NEST);
    eval 'sub NFA_TYPE {
        my($attr) = @_;
	    eval q((($attr)-> &nfa_type & 0x7fff));
    }' unless defined(&NFA_TYPE);
    eval 'sub NFA_ALIGNTO () {4;}' unless defined(&NFA_ALIGNTO);
    eval 'sub NFA_ALIGN {
        my($len) = @_;
	    eval q(((($len) +  &NFA_ALIGNTO - 1) & ~( &NFA_ALIGNTO - 1)));
    }' unless defined(&NFA_ALIGN);
    eval 'sub NFA_OK {
        my($nfa,$len) = @_;
	    eval q((($len) > 0 && ($nfa)-> &nfa_len >= $sizeof{\'struct nfattr\'}  && ($nfa)-> &nfa_len <= ($len)));
    }' unless defined(&NFA_OK);
    eval 'sub NFA_NEXT {
        my($nfa,$attrlen) = @_;
	    eval q((($attrlen) -=  &NFA_ALIGN(($nfa)-> &nfa_len), ((($nfa)) +  &NFA_ALIGN(($nfa)-> &nfa_len))));
    }' unless defined(&NFA_NEXT);
    eval 'sub NFA_LENGTH {
        my($len) = @_;
	    eval q(( &NFA_ALIGN($sizeof{\'struct nfattr\'}) + ($len)));
    }' unless defined(&NFA_LENGTH);
    eval 'sub NFA_SPACE {
        my($len) = @_;
	    eval q( &NFA_ALIGN( &NFA_LENGTH($len)));
    }' unless defined(&NFA_SPACE);
    eval 'sub NFA_DATA {
        my($nfa) = @_;
	    eval q((( &void *)((($nfa)) +  &NFA_LENGTH(0))));
    }' unless defined(&NFA_DATA);
    eval 'sub NFA_PAYLOAD {
        my($nfa) = @_;
	    eval q(((($nfa)-> &nfa_len) -  &NFA_LENGTH(0)));
    }' unless defined(&NFA_PAYLOAD);
    eval 'sub NFA_NEST {
        my($skb, $type) = @_;
	    eval q(({ \'struct nfattr\' * &__start =  &skb_tail_pointer($skb);  &NFA_PUT($skb, ( &NFNL_NFA_NEST | $type), 0,  &NULL);  &__start; }));
    }' unless defined(&NFA_NEST);
    eval 'sub NFA_NEST_END {
        my($skb, $start) = @_;
	    eval q(({ ($start)-> &nfa_len =  &skb_tail_pointer($skb) - ($start); ($skb)-> &len; }));
    }' unless defined(&NFA_NEST_END);
    eval 'sub NFA_NEST_CANCEL {
        my($skb, $start) = @_;
	    eval q(({  &if ($start)  &skb_trim($skb,  ($start) - ($skb)-> &data); -1; }));
    }' unless defined(&NFA_NEST_CANCEL);
    eval 'sub NFM_NFA {
        my($n) = @_;
	    eval q((((($n)) +  &NLMSG_ALIGN($sizeof{\'struct nfgenmsg\'}))));
    }' unless defined(&NFM_NFA);
    eval 'sub NFM_PAYLOAD {
        my($n) = @_;
	    eval q( &NLMSG_PAYLOAD($n, $sizeof{\'struct nfgenmsg\'}));
    }' unless defined(&NFM_PAYLOAD);
}
1;
